<?php
 /*
 #########################################################################
 #                       xt:Commerce  4.1 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce  4.1 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id$
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

include_once _SRV_WEBROOT . 'xtFramework/admin/classes/class.adminDB_DataSave.php';
include_once _SRV_WEBROOT.'plugins/xt_pro_import/lib/class.csv_field.php';
include_once _SRV_WEBROOT.'plugins/xt_pro_import/classes/class.xt_pro_import_fields_settings.php';
include_once _SRV_WEBROOT._SRV_WEB_FRAMEWORK.'classes/class.FileHandler.php';

class csv_pro_api {

	var $limit = '1000';
	var $limit_lower = 0;
	var $limit_upper = 0;
	var $delimiter = '|';
	var $counter_new = 0;
	var $counter_update = 0;
	var $version = '1.0';
	var $_table_log = TABLE_PROIMPORTPLUGIN_LOG;
    var $CAT_TREE = array();
    var $_objectMapping = array();

	function csv_pro_api() {}
	
	function clearLog() {
		global $db;
		$db->Execute("DELETE FROM ".$this->_table_log." WHERE ei_id='".$this->id."'");
	}
	
	function addLog($message) {
		global $db;
		$data = array();
		$data['ei_id']=$this->id;
		$data['error_message']=$message;
		$db->AutoExecute($this->_table_log,$data);
	}
	
	
	/**
	 * check if login credentials matching db
	 *
	 * @param unknown_type $data
	 */
	function _checkCredentials($data) {
		
		if ($this->_recordData['ei_username']!='') {
			if ($this->_recordData['ei_username']!=$data['user']) die ('- wrong login -');
		}
		
		if ($this->_recordData['ei_password']!='') {
			if ($this->_recordData['ei_password']!=$data['password']) die ('- wrong login -');
		}
		
	}

	/**
	 * get fieldnames of given table
	 *
	 * @param string $table
	 * @return array
	 */
	function readTabelFields ($table) {
		global $db;
		static $tableFieldsCache = array();
		
		if (isset($tableFieldsCache[$table])) {
			return $tableFieldsCache[$table];
		}
		$query = "SHOW FIELDS FROM ".$table." ";
		$record = $db->Execute($query);
		$records = array();
		if ($record->RecordCount() > 0) {
			while(!$record->EOF){
				$records[$record->fields['Field']] = $record->fields;
				$record->MoveNext();
			} $record->Close();
		}
		
		$tableFieldsCache[$table] = $records;
		return $records;
	}
	
	protected function hasFieldsForInsert($table, $data) {
		$tableFields = array_keys($this->readTabelFields($table));
		
		foreach ($tableFields as $field) {
			foreach ($data as $columnName => $columnValue) {
				if (substr($columnName, 0, strlen($field)) == $field) {
					return true;
				}
			}
		}
		
		return false;
	}
	
	function _checkKeyImport($array,$type='primary') {
		if ($type=='primary') {
			if (!in_array($this->primary,$array)) die (' primary <b>'.$this->primary.'</b> not allowed');
		}
		if ($type=='secondary') {
			if (!in_array($this->secondary,$array)) die (' secondary <b>'.$this->secondary.'</b> not allowed');
		}
	}

	function _checkKeyExport($array,$type='primary') {
		if ($type=='primary') {
			if (!in_array($this->primary,$array)) die (' primary <b>'.$this->primary.'</b> not allowed');
		}
		if ($type=='secondary') {
			if (!in_array($this->secondary,$array)) die (' secondary <b>'.$this->secondary.'</b> not allowed');
		}
	}

	function _filterInput(&$data) {
		foreach ($data as $key => $val) {
				$data[$key] = addslashes(trim($val));
		}
	}

	function str_getcsv ($data, $delim, $encl) {
		$fp = fopen('php://temp/', 'r+');
		fputs ($fp, $data);
		rewind ($fp);
		$d = fgetcsv  ($fp, 0, $delim, $encl);
		fclose ($fp);
		return $d;
	} // str_getcsv()
	/**
	 * parse data of specific line, return trim array
	 *
	 * @param int $line
	 * @return array
	 */
	function _parseLineData($line) {
		$data = $this->str_getcsv ($this->filedata[$line], $this->delimiter, $this->enclosure);
		
		$count = count($data);
		$line_data = array();
		for ($i = 0; $i < $count; $i++) {
			$fieldValue = trim(str_replace(array("\n", "\r", "\n\r"), '', $data[$i]),'"');
			$fieldName = $this->mapping[$i];
			// If there is no mapped field for this column skip
			if (!isset($this->_objectMapping[$fieldName]))
				continue;
			$line_data[$fieldName] = $fieldValue;
		}
		return $line_data;
	}
	
	/**
	 * Get exported fields
	 * @return array
	 */
	function getExportedFields() {
		switch ($this->type) {
			case 'products':
				return $this->getProductsFields();
			default:
				return array();
		}
	}
	
	function getProductsFields() {
		global $db, $language;
	
		$fields = array();
		$query = "SELECT * FROM ".TABLE_PROIMPORTPLUGIN_FIELDS_MAPPING." WHERE proimportplugin_id=" . (int)$this->_recordData['id'] . " AND csv_field != '' ORDER BY sort_order ASC";
		$rs = $db->Execute($query);
	
		if ($rs->RecordCount()==0)
			return $fields;
	
		while (!$rs->EOF) {
			$records = $rs->fields;
			$fields[] = new csv_field($records);
			$rs->MoveNext();
		}$rs->Close();
		
		$product_description_table_fields = $this->readTabelFields(TABLE_PRODUCTS_DESCRIPTION);
		$product_seo_url_table_fields = $this->readTabelFields(TABLE_SEO_URL);
		
		if ($this->_recordData['ei_language']==1) {
			$_language_list = $language->_getLanguageList();
		} else {
			$defaultLanguage = array('code' => _STORE_LANGUAGE);
			$_language_list = array($defaultLanguage);
		}
			
		$tmp = array();
			
		foreach ($fields as $fieldObj) {
			if (isset($product_description_table_fields[$fieldObj->getStoreField()]) && $fieldObj->getStoreField() != 'products_id') {
				foreach ($_language_list as $languageData) {
					$copy = clone $fieldObj;
					$copy->setStoreField($fieldObj->getStoreField() . '_' . $languageData['code']);
					$csvFieldSuffix = ($this->_recordData['ei_language']==1) ? '_' . $languageData['code'] : '';
					$copy->setCsvField($fieldObj->getCsvField() . $csvFieldSuffix);
					$tmp[] = $copy;
					unset($copy);
				}
			} else if (isset($product_seo_url_table_fields[$fieldObj->getStoreField()]) && !in_array($fieldObj->getStoreField(), array('url_md5', 'language_code', 'link_type', 'link_id'))) {
				foreach ($_language_list as $languageData) {
					$copy = clone $fieldObj;
					$copy->setStoreField($fieldObj->getStoreField() . '_' . $languageData['code']);
					$csvFieldSuffix = ($this->_recordData['ei_language']==1) ? '_' . $languageData['code'] : '';
					$copy->setCsvField($fieldObj->getCsvField() . $csvFieldSuffix);
					$tmp[] = $copy;
					unset($copy);
				}
			} else {
				$tmp[] = $fieldObj;
			}
		}
			
		$fields = $tmp;
		
		return $fields;
	}
	
	/**
	 * query for export/import dataset
	 *
	 * @param int $id
	 */
	function getDetails($id) {
		global $db,$filter;
		
		$sql = "SELECT * FROM ".TABLE_PROIMPORTPLUGIN." WHERE ei_id = '".$filter->_charNum($id)."'";
		$rs = $db->Execute($sql);
		if ($rs->RecordCount()!=1) return false;
		
		if ($this->_recordData['ei_delimiter']!='') $this->delimiter=$this->_recordData['ei_delimiter'];
		
		$this->_recordData = $rs->fields;
		return true;

	}
	
	/**
	 * set starttime in log
	 *
	 * @param unknown_type $id
	 */
	function _startExport($id) {
		global $logHandler;
		
		$log_data= array();
		$log_data['message'] = 'start';
		$log_data['time'] = time();
		$logHandler->_addLog('success','xt_im_export',$id,$log_data);
		
	}
	
	/**
	 * set endtime in log
	 *
	 * @param unknown_type $id
	 */
	function _stopExport($id) {
		global $logHandler;
		$log_data= array();
		$log_data['message'] = 'stop';
		$log_data['time'] = time();
		$logHandler->_addLog('success','xt_im_export',$id,$log_data);
	}
	
	function showLog($id) {
		global $logHandler;
		 
		$logHandler->showLog('xt_im_export', $id);
	}

    function _insertCategory($category_tree,$products_id) {
        global $db;

        // tree node allready known?
        if (isset($this->CAT_TREE[$category_tree])) {
            $this->_insertProd2Cat($this->CAT_TREE[$category_tree],$products_id);
        } else {
            // split tree
            $tree = explode($this->cat_tree_delimiter,$category_tree);

            $cat = $this->processTree($tree,_STORE_LANGUAGE);
            if (!isset($this->CAT_TREE[$category_tree]))$this->CAT_TREE[$category_tree]=$cat;
            $this->_insertProd2Cat($cat,$products_id);
        }
    }

    private function processTree($tree,$language='de') {
        global $db,$_language_list;

        $parent_id = 0;

        foreach ($tree as $id => $name) {

        	$name = trim($name);
            // check if category exists
            $qry = "SELECT c.categories_id FROM ".TABLE_CATEGORIES." c, ".TABLE_CATEGORIES_DESCRIPTION." cd WHERE cd.categories_name='".addslashes($name)."' and cd.language_code='".$language."' and cd.categories_id=c.categories_id and parent_id='".$parent_id."' LIMIT 0,1";

            $rs = $db->Execute($qry);
            if ($rs->RecordCount()==0) {

                $categorie_data = array();
                $db->Execute("INSERT INTO " . TABLE_CATEGORIES . " (parent_id) VALUES ('" . $parent_id . "')");
                $categorie_data['categories_id'] = $db->Insert_ID();

                // add category
                $categorie_data['parent_id']=$parent_id;
                $categorie_data['categories_status']='1';
                foreach ($this->_language_list as $key => $val) {
                    $categorie_data['categories_name_'.$val['code']]=$name;
                }

                $category = new category;
                $obj = new stdClass;
                $obj=$category->_set($categorie_data);
                $parent_id=$categorie_data['categories_id'];

            } else {
                $parent_id=$rs->fields['categories_id'];
            }

        }
        return $parent_id;

    }
    
    /**
     * Downloads image from external source
     * @param string $url Url from where to download
     * @param string $downloadTo Destination folder
     */
    public static function downloadImage($url, $downloadTo) {
    	global $db;
    	// Get name of the image
    	// TODO extension validation
    	$fileName = basename($url);
    	$fileHandler = new FileHandler();
    	// Clean file name
    	$fileName = $fileHandler->cleanFileName($fileName);
    	
    	// If file already exists there is nothing to do
    	if (file_exists($downloadTo . $fileName)) {
    		// If the image exists we assume that it also has thumbs created
    		// no need to go through whole process, just return the name
    		//self::createThumbs($fileName);
    		return $fileName;
    	}
    	
    	try {
	    	set_time_limit(0);
	    	$fp = fopen ($downloadTo . $fileName, 'w+');//This is the file where we save the information
	    	$ch = curl_init(str_replace(" ","%20",$url));//Here is the file we are downloading, replace spaces with %20
	    	curl_setopt($ch, CURLOPT_TIMEOUT, 50);
	    	curl_setopt($ch, CURLOPT_FILE, $fp); // write curl response to file
	    	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	    	curl_exec($ch); // get curl response
	    	curl_close($ch);
	    	fclose($fp);
    	} catch (Exception $e) {
    		// Free resources
    		curl_close($ch);
    		fclose($fp);
    		return '';
    	}
    	self::createThumbs($fileName);
    	// Insert record for the new image
    	$image_data = array(
    		'file' => $fileName,
    		'type' => 'images',
    		'class' => 'product',
    	);
    	$m_data = new MediaData();
    	$m_data->setClass('product');
    	$m_data->setMediaData($image_data);
		
    	return $fileName;
    }
    
    /**
     * Creates thumbs for product image
     * @param string $fileName
     */
    public static function createThumbs($fileName) {
    	$mediaImages = new MediaImages();
    	$mediaImages->setPath('media' . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR);
    	$mediaImages->setClass('default');
    	$mediaImages->processImage($fileName);
    }
    
    /**
     * Get manufacturer id by name, creating one if it doesn't exists yet.
     * @param string $manufacturerName
     * @return int
     */
    public static function getManufacturerIdByName($manufacturerName) {
    	global $db, $language, $seo;
    	// Cache
    	static $_allManufacturers = array();
    	
    	// Preload data only once
    	if (empty($_allManufacturers)) {
    		$query = 'SELECT manufacturers_id, manufacturers_name FROM ' . TABLE_MANUFACTURERS;
    		$rs = $db->Execute($query);
    		
    		if ($rs->RecordCount()>0) {
    			while (!$rs->EOF) {
    				$records = $rs->fields;
    				$_allManufacturers[$records['manufacturers_name']] = $records['manufacturers_id'];
    				$rs->MoveNext();
    			}$rs->Close();
    		}
    	}
    	
    	// Manufacturer doesnt exist create new record
    	if (!isset($_allManufacturers[$manufacturerName])) {
    		$data = array('manufacturers_name' => $manufacturerName, 'date_added' => date('Y-m-d h:i:s', strtotime('now')));
    		$db->AutoExecute(TABLE_MANUFACTURERS, $data);
    		$manufacturerId = $db->Insert_ID();
    		$data['manufacturers_id'] = $manufacturerId;
    		// Add to cache
    		$_allManufacturers[$manufacturerName] = $manufacturerId;
    		
    		$_language_list = $language->_getLanguageList();
    		
    		foreach ($_language_list as $key => $val) {
    			$db->AutoExecute(TABLE_MANUFACTURERS_DESCRIPTION, array('manufacturers_id' => $manufacturerId, 'language_code' => $val['code']));
    			// Set seo for this manufacturer
    			$auto_generate = true;
    			$data['url_text_'.$val['code']] = $data['manufacturers_name'];
    			$seo->_UpdateRecord('manufacturer', $data['manufacturers_id'], $val['code'], $data,$auto_generate);
    		}
    	} else {
    		$manufacturerId = $_allManufacturers[$manufacturerName];
    	}
    	// Return the Id
    	return $manufacturerId;
    }

    /**
     * Get supported fields for given type
     * @param string $type
     * @return array
     */
    public static function getSupporttedFieldsForType($type) {
    	if ($type == 'products') {
    		$api = new csv_pro_api();
    		$supportedFields = array();
    			
    		// Get all columns from products table
    		$results = $api->readTabelFields(TABLE_PRODUCTS);
    		$records = array();
    		foreach ($results as $table_field => $rsData) {
    			$records[$table_field] = $table_field;
    		}
    		unset($results);
    			
    		$supportedFields = array_merge($supportedFields, $records);
    			
    		// Get all fields from product_description table
    		$results = $api->readTabelFields(TABLE_PRODUCTS_DESCRIPTION);
    		$records = array();
    		foreach ($results as $table_field => $rsData) {
    			$records[$table_field] = $table_field;
    		}
    		unset($results);
    		$supportedFields = array_merge($supportedFields, $records);
    		
    		// Get all fields from seo_url table
    		$results = $api->readTabelFields(TABLE_SEO_URL);
    		$records = array();
    		foreach ($results as $table_field => $rsData) {
    			$records[$table_field] = $table_field;
    		}
    		unset($results);
    		$supportedFields = array_merge($supportedFields, $records);
    		// Categories
    		$supportedFields['categories'] = 'categories';	
    		$supportedFields['categories_tree'] = 'categories_tree';
    		
    		$skippedFields = array('price_flag_graduated_all', 'price_flag_special_all', 'flag_has_specials', 'language_code', 'url_md5', 'link_type', 'link_id');
    		foreach ($supportedFields as $key => $field) {
    			if (in_array($field, $skippedFields) || (strpos($field, 'price_flag_graduated') !== false)) {
    				unset($supportedFields[$key]);
    			}
    		}
    		
    		return $supportedFields;
    	}
    	
    	return array();
    }
    
    /**
     * Get header columns from csv file
     * @param string $file Root path to the file
     * @param string $delimiter
     * @param string $enclosure
     * @return array
     */
    public static function getCsvColumns($file, $delimiter, $enclosure) {
    	global $language;
    	
    	$fp = fopen($file, 'r');
    	// Workaround for delimiter like \t\t where it will be passed as single quoted string and will not be evaluated
    	eval("\$delimiter = \"$delimiter\";");
    	// Read CSV header line to get available columns
    	$row = fgetcsv($fp, 0, $delimiter, $enclosure);
    	fclose($fp);
    		
    	$_language_list = $language->_getLanguageList();
    	$languageCodes = array();
    		
    	// Prepare active language codes to determine later if given field is multilanguage
    	foreach ($_language_list as $LanguageData) {
    		$languageCodes[$LanguageData['code']] = $LanguageData['code'];
    	}
    	$groupedColumns = array();
    		
    	foreach ($row as $field) {
    		// Check if the field is multilanguage usually it will end up with *_[language suffix with length of 2]
    		// so we get last three symbols e.g. _en, _de etc.
    		$fieldSuffix = substr($field, -3, 3);
    		// If it is multilanguage field remove language suffix
    		if (in_array(str_replace('_', '', $fieldSuffix), $languageCodes)) {
    			$field = str_replace($fieldSuffix, '', $field);
    		}
    	
    		// Add to coluns array
    		$groupedColumns[$field] = $field;
    	}
    	
    	return $groupedColumns;
    }
    
    private function _insertProd2Cat($categories_id,$products_id) {
        global $db;

        $db->Execute("DELETE FROM ".TABLE_PRODUCTS_TO_CATEGORIES." WHERE products_id='".$products_id."'");
        $cat_data = array();
        $cat_data['categories_id']=$categories_id;
        $cat_data['products_id']=$products_id;
        $cat_data['master_link']='1';
        $db->AutoExecute(TABLE_PRODUCTS_TO_CATEGORIES,$cat_data);

    }
	
	function _clearLog($id) {
		global $logHandler;
		$logHandler->clearLogMessages('xt_im_export', $id);
	}

	function _displayHTML($next_target,$lower=1,$upper=0,$total=0) {

		$process = $lower / $total * 100;
		if ($process>100) $process=100;
		
		$html='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="refresh" content="5; URL='.$next_target.'" />
<title>..import / export..</title>
<style type="text/css">
<!--
.process_rating_light .process_rating_dark {
background:#FF0000;
height:15px;
position:relative;
}

.process_rating_light {
height:15px;
margin-right:5px;
position:relative;
width:150px;
border:1px solid;
}

-->
</style>
</head>
<body>
<div class="process_rating_light"><div class="process_rating_dark" style="width:'.$process.'%">'.round($process,0).'%</div></div>
Processing '.$lower.' to '.$upper.' of total '.$total.'
</body>
</html>';
		return $html;

	}
	
	
	function _htmlHeader() {
		$html='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>..import / export..</title>
<style type="text/css">
<!--
ul.stack {padding:5px}
ul.stack li {}
ul.stack li.success {list-style:none; padding:5px 0px 2px 20px; background-image:url(xtAdmin/images/icons/accept.png); background-repeat:no-repeat; background-position:0px 4px;}
ul.stack li.error {list-style:none; padding:5px 0px 2px 20px; background-image:url(xtAdmin/images/icons/cross.png); background-repeat:no-repeat; background-position:0px 4px;}
-->
</style>
</head>
<body>';
		return $html;
	}
	
	function _htmlFooter() {
		$html ='</body></html>';
		return $html;
	}
	

}

?>